unit guitabbase;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, xmlUtil;

type

  { TGuiTab }

  TGuiTab = class(TFrame)
   type
    TClassType = class of TGuiTab;
    TGuiType = record
     code : TClassType;
     name : String;
     desc : String;
    end;
   private
    _xmlEl : XML.TElement;
    class var _availlable : Array of TGuiType;
    class function readAvaillable(i: cardinal): TGuiType; static;
   public
    constructor create(theOwner:TControl; __xmlEl:XML.TElement); virtual; overload;
    constructor create(theOwner:TControl);
    class property availlable[i:cardinal] : TGuiType read readAvaillable;
    class function availlableCount : cardinal;
    class procedure addAvaillable(_name:String; desc:String; code:TClassType);
    property xmlEl : XML.TElement read _xmlEl;
  end;

implementation

{$R *.lfm}

{ TGuiTab }

constructor TGuiTab.create(theOwner: TControl; __xmlEl: XML.TElement);
begin
  inherited create(theOwner);
  _xmlEl := __xmlEl;
end;

constructor TGuiTab.create(theOwner: TControl);
begin
  raise Exception.create('Use the constructor with xmlEl!');
end;

class function TGuiTab.readAvaillable(i: cardinal): TGuiType; static;
begin
  result := _availlable[i];
end;

class function TGuiTab.availlableCount: cardinal;
begin
  result := length(_availlable);
end;

class procedure TGuiTab.addAvaillable(_name: String; desc: String; code: TClassType);
var i : integer;
begin
  i := length(_availlable);
  setLength(_availlable, i+1);
  _availlable[i].code := code;
  _availlable[i].name := _name;
  _availlable[i].desc := desc;
end;

initialization
TGuiTab._availlable := nil;

end.

